package org.exoplatform.jcr.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.client.http.HttpClientInfo;
import org.exoplatform.services.database.HibernateServiceContainer;

public class JcrFilter implements Filter {

  private String portalName_;
  private HibernateServiceContainer hserviceContainer_;

  public void init(FilterConfig filterConfig) {
    portalName_ = filterConfig.getServletContext().getServletContextName();
    PortalContainer pcontainer = RootContainer.getInstance()
        .getPortalContainer(portalName_);
    hserviceContainer_ = (HibernateServiceContainer) pcontainer
        .getComponentInstanceOfType(HibernateServiceContainer.class);
  }

  public void doFilter(ServletRequest servletRequest,
      ServletResponse servletResponse, FilterChain filterChain)
      throws IOException, ServletException {
    SessionContainer sessionContainer = null;
    try {
      String name = Thread.currentThread().getName();
      PortalContainer pcontainer = RootContainer.getInstance()
          .getPortalContainer(portalName_);
      PortalContainer.setInstance(pcontainer);
      
      HttpServletRequest httpRequest = (HttpServletRequest) servletRequest ;
      HttpSession session =  httpRequest.getSession();
      sessionContainer = (SessionContainer)pcontainer.getComponentInstance(
         session.getId());      
      if(sessionContainer == null) {
        sessionContainer = pcontainer.createSessionContainer(session.getId(), "default") ;       
        sessionContainer.getMonitor().setClientInfo(new HttpClientInfo(httpRequest)) ;
      }
      //attach to current thread
      SessionContainer.setInstance(sessionContainer);      
      filterChain.doFilter(servletRequest, servletResponse);
    } finally {
      hserviceContainer_.closeAllSessions();
      if(sessionContainer != null)sessionContainer.endActionLifcycle() ;
      PortalContainer.setInstance(null) ;      
    }
  }

  public void destroy() {
  }

}
